Bug 1419366 - Review Request: pybind11 - Seamless operability between C++11 and Python
Summary: Review Request: pybind11 - Seamless operability between C++11 and Python
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Antonio T. (sagitter)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-SCITECH 1419365
TreeView+ depends on / blocked
 
Reported: 2017-02-05 23:51 UTC by Susi Lehtola
Modified: 2017-04-27 20:50 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-04-27 05:50:31 UTC
Type: ---
anto.trande: fedora-review+


Attachments (Terms of Use)
Build log from mock-f25 (94.11 KB, text/plain)
2017-02-24 11:27 UTC, Antonio T. (sagitter)
no flags Details

Description Susi Lehtola 2017-02-05 23:51:20 UTC
Spec URL: https://jussilehtola.fedorapeople.org/pybind11.spec
SRPM URL: https://jussilehtola.fedorapeople.org/pybind11-2.0.1-1.fc25.src.rpm
Fedora Account System Username: jussilehtola

Description:
pybind11 is a lightweight header-only library that exposes C++ types
in Python and vice versa, mainly to create Python bindings of existing
C++ code.

Comment 1 Antonio T. (sagitter) 2017-02-22 17:17:21 UTC
cmake tests failed:

-- Performing Test HAS_LTO_FLAG - Success
CMake Error at tests/CMakeLists.txt:94 (message):
  Running the tests requires pytest.  Please install it manually (try:
  /usr/bin/python3.6 -m pip install pytest)
-- Configuring incomplete, errors occurred!
See also "/builddir/build/BUILD/pybind11-2.0.1/CMakeFiles/CMakeOutput.log".
error: Bad exit status from /var/tmp/rpm-tmp.odmUov (%build)
RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.odmUov (%build)

Comment 2 Susi Lehtola 2017-02-22 20:47:34 UTC
Thanks for taking this.

pytest was already in the BR, switched to python3 for tests. Now mock build works.


Spec URL: https://jussilehtola.fedorapeople.org/pybind11.spec
SRPM URL: https://jussilehtola.fedorapeople.org/pybind11-2.0.1-2.fc25.src.rpm

Comment 3 Antonio T. (sagitter) 2017-02-23 16:04:23 UTC
Still in error:

[  6%] Building CXX object tests/CMakeFiles/pybind11_tests.dir/pybind11_tests.cpp.o
cd /builddir/build/BUILD/pybind11-2.0.1/tests && /usr/bin/c++   -DPYBIND11_TEST_EIGEN -Dpybind11_tests_EXPORTS -I/builddir/build/BUILD/pybind11-2.0.1/include -I/usr/include/python3.6m -I/usr/include/eigen3  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -DNDEBUG -fPIC   -std=c++14 -flto -fvisibility=hidden -Wall -Wextra -Wconversion -o CMakeFiles/pybind11_tests.dir/pybind11_tests.cpp.o -c /builddir/build/BUILD/pybind11-2.0.1/tests/pybind11_tests.cpp
In file included from /builddir/build/BUILD/pybind11-2.0.1/tests/pybind11_tests.h:2:0,
                 from /builddir/build/BUILD/pybind11-2.0.1/tests/test_alias_initialization.cpp:11:
/builddir/build/BUILD/pybind11-2.0.1/include/pybind11/pybind11.h:62:22: internal compiler error: in mangle_decl, at cp/mangle.c:3845
         initialize([f](Class *c, Arg... args) -> Return { return (c->*f)(args...); },
                      ^
Please submit a full bug report,
with preprocessed source if appropriate.
See <http://bugzilla.redhat.com/bugzilla> for instructions.

Comment 4 Susi Lehtola 2017-02-23 19:12:10 UTC
That's a bug in the unstable gcc in rawhide. Please build against f25, where it works.

Comment 5 Susi Lehtola 2017-02-23 19:16:11 UTC
I can't actually reproduce your error. Builds fine for me in mock both for Fedora 25 and rawhide.

Comment 6 Susi Lehtola 2017-02-23 20:48:43 UTC
OK, there's a weird problem on i686 and ppc64, see
https://koji.fedoraproject.org/koji/taskinfo?taskID=18017637

Filed ticket upstream at
https://github.com/pybind/pybind11/issues/694

Comment 7 Susi Lehtola 2017-02-23 20:51:34 UTC
Due to the architure dependent failure, it's probably better to bend the rules a little bit and drop BuildArch: noarch so that the package gets built and tested on all architectures. I'm now also running the tests against both python2 and python3.

Spec URL: https://jussilehtola.fedorapeople.org/pybind11.spec
SRPM URL: https://jussilehtola.fedorapeople.org/pybind11-2.0.1-3.fc25.src.rpm

Comment 8 Antonio T. (sagitter) 2017-02-24 11:27:00 UTC
Created attachment 1257192 [details]
Build log from mock-f25

Tests are failing, even on Fedora 25.

Comment 9 Susi Lehtola 2017-02-26 21:54:22 UTC
(In reply to Antonio Trande from comment #8)
> Created attachment 1257192 [details]
> Build log from mock-f25
> 
> Tests are failing, even on Fedora 25.

Yeah that was already in comment #6.

**

I've resolved the issues with upstream, as discussed in the ticket of comment #6. Now the package builds correctly on all architectures.

Spec URL: https://jussilehtola.fedorapeople.org/pybind11.spec
SRPM URL: https://jussilehtola.fedorapeople.org/pybind11-2.0.1-4.fc25.src.rpm

Comment 10 Susi Lehtola 2017-02-26 22:14:33 UTC
Note that it's theoretically possible for pybind11 to start shipping a runtime library at some point, so arching the package now isn't that bad.

Comment 11 Antonio T. (sagitter) 2017-02-27 17:29:44 UTC
Shouldn't provide both python2 and python3 package?

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Header files in -devel subpackage, if present.
  Note: pybind11 : /usr/include/pybind11/attr.h pybind11 :
  /usr/include/pybind11/cast.h pybind11 : /usr/include/pybind11/chrono.h
  pybind11 : /usr/include/pybind11/common.h pybind11 :
  /usr/include/pybind11/complex.h pybind11 : /usr/include/pybind11/descr.h
  pybind11 : /usr/include/pybind11/eigen.h pybind11 :
  /usr/include/pybind11/eval.h pybind11 :
  /usr/include/pybind11/functional.h pybind11 :
  /usr/include/pybind11/numpy.h pybind11 :
  /usr/include/pybind11/operators.h pybind11 :
  /usr/include/pybind11/options.h pybind11 :
  /usr/include/pybind11/pybind11.h pybind11 :
  /usr/include/pybind11/pytypes.h pybind11 : /usr/include/pybind11/stl.h
  pybind11 : /usr/include/pybind11/stl_bind.h pybind11 :
  /usr/include/pybind11/typeid.h
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Cannot run licensecheck: Command 'licensecheck -r /var/lib/mock
     /fedora-rawhide-x86_64/root/builddir/build/BUILD/pybind11-2.0.1'
     returned non-zero exit status 25

'licensecheck' executed manually.

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: pybind11-2.0.1-4.fc26.x86_64.rpm
          pybind11-2.0.1-4.fc26.src.rpm
pybind11.x86_64: W: spelling-error Summary(en_US) operability -> penetrability, permeability, portability
pybind11.x86_64: W: spelling-error %description -l en_US versa -> avers, verse, verso
pybind11.x86_64: E: no-binary
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/stl_bind.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/chrono.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/pytypes.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/typeid.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/operators.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/common.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/functional.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/attr.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/numpy.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/complex.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/descr.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/eigen.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/cast.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/options.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/pybind11.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/eval.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/stl.h
pybind11.src: W: spelling-error Summary(en_US) operability -> penetrability, permeability, portability
pybind11.src: W: spelling-error %description -l en_US versa -> avers, verse, verso
pybind11.src:4: W: mixed-use-of-spaces-and-tabs (spaces: line 4, tab: line 4)
2 packages and 0 specfiles checked; 1 errors, 22 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
pybind11.x86_64: W: spelling-error Summary(en_US) operability -> penetrability, permeability, portability
pybind11.x86_64: W: spelling-error %description -l en_US versa -> avers, verse, verso
pybind11.x86_64: E: no-binary
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/attr.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/cast.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/chrono.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/common.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/complex.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/descr.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/eigen.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/eval.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/functional.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/numpy.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/operators.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/options.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/pybind11.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/pytypes.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/stl.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/stl_bind.h
pybind11.x86_64: W: devel-file-in-non-devel-package /usr/include/pybind11/typeid.h
1 packages and 0 specfiles checked; 1 errors, 19 warnings.



Requires
--------
pybind11 (rpmlib, GLIBC filtered):
    cmake



Provides
--------
pybind11:
    pybind11
    pybind11(x86-64)
    pybind11-devel



Source checksums
----------------
https://github.com/pybind/pybind11/archive/v2.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : d18383097455cab02e9ff312eaf472e36ae26c3ff46e250b790ddc5ec336fa5c
  CHECKSUM(SHA256) upstream package : d18383097455cab02e9ff312eaf472e36ae26c3ff46e250b790ddc5ec336fa5c


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review --mock-options=--no-clean -m fedora-rawhide-x86_64 -rn pybind11-2.0.1-4.fc25.src.rpm
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 12 Antonio T. (sagitter) 2017-02-27 17:31:40 UTC
You should also add gcc-c++ as BR package.

Comment 13 Susi Lehtola 2017-02-27 18:23:00 UTC
(In reply to Antonio Trande from comment #11)
> Shouldn't provide both python2 and python3 package?

No, the package consists of C++ headers, it's not Python. The tests are built and run against both python2 and python3.

> Issues:
> =======
> - Header files in -devel subpackage, if present.
>   Note: pybind11 : /usr/include/pybind11/attr.h pybind11 :
>   /usr/include/pybind11/cast.h pybind11 : /usr/include/pybind11/chrono.h
>   pybind11 : /usr/include/pybind11/common.h pybind11 :
>   /usr/include/pybind11/complex.h pybind11 : /usr/include/pybind11/descr.h
>   pybind11 : /usr/include/pybind11/eigen.h pybind11 :
>   /usr/include/pybind11/eval.h pybind11 :
>   /usr/include/pybind11/functional.h pybind11 :
>   /usr/include/pybind11/numpy.h pybind11 :
>   /usr/include/pybind11/operators.h pybind11 :
>   /usr/include/pybind11/options.h pybind11 :
>   /usr/include/pybind11/pybind11.h pybind11 :
>   /usr/include/pybind11/pytypes.h pybind11 : /usr/include/pybind11/stl.h
>   pybind11 : /usr/include/pybind11/stl_bind.h pybind11 :
>   /usr/include/pybind11/typeid.h
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages

Files are now in -devel, as outlined in
https://fedoraproject.org/wiki/Packaging:Guidelines#Packaging_Header_Only_Libraries

(In reply to Antonio Trande from comment #12)
> You should also add gcc-c++ as BR package.

Huh, looks like the guidelines have changed, I couldn't find the list of minimal buildroot packages anymore! Added.

**

Spec URL: https://jussilehtola.fedorapeople.org/pybind11.spec
SRPM URL: https://jussilehtola.fedorapeople.org/pybind11-2.0.1-5.fc25.src.rpm

Comment 14 Antonio T. (sagitter) 2017-02-27 18:38:42 UTC
Package approved.

Comment 15 Gwyn Ciesla 2017-02-27 19:03:53 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/pybind11

Comment 16 Fedora Update System 2017-02-28 15:05:14 UTC
pybind11-2.0.1-5.fc25 psi4-1.0-1.926879egit.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-096890604d

Comment 17 Fedora Update System 2017-02-28 15:05:27 UTC
pybind11-2.0.1-5.fc24 psi4-1.0-1.926879egit.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-31ced2cf47

Comment 18 Fedora Update System 2017-03-01 02:51:52 UTC
psi4-1.0-1.926879egit.fc24, pybind11-2.0.1-5.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-31ced2cf47

Comment 19 Fedora Update System 2017-03-01 02:54:53 UTC
psi4-1.0-1.926879egit.fc25, pybind11-2.0.1-5.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-096890604d

Comment 20 Fedora Update System 2017-03-10 19:05:19 UTC
psi4-1.0-2.2118f2fgit.fc25 pybind11-2.0.1-5.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-096890604d

Comment 21 Fedora Update System 2017-03-10 19:05:33 UTC
psi4-1.0-2.2118f2fgit.fc24 pybind11-2.0.1-5.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-31ced2cf47

Comment 22 Fedora Update System 2017-03-11 13:53:14 UTC
psi4-1.0-2.2118f2fgit.fc24, pybind11-2.0.1-5.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-31ced2cf47

Comment 23 Fedora Update System 2017-03-11 14:24:30 UTC
psi4-1.0-2.2118f2fgit.fc25, pybind11-2.0.1-5.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-096890604d

Comment 24 Fedora Update System 2017-04-27 05:50:31 UTC
psi4-1.0-2.2118f2fgit.fc25, pybind11-2.0.1-5.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 25 Fedora Update System 2017-04-27 20:50:32 UTC
psi4-1.0-2.2118f2fgit.fc24, pybind11-2.0.1-5.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.